hw/{misc, riscv}: pfsoc: add system controller as unimplemented
[qemu.git] / configure
blob9f0bc57546de8f2ecd1545e75433a06a0526901d
1 #!/bin/sh
3 # qemu configure script (c) 2003 Fabrice Bellard
6 # Unset some variables known to interfere with behavior of common tools,
7 # just as autoconf does.
8 CLICOLOR_FORCE= GREP_OPTIONS=
9 unset CLICOLOR_FORCE GREP_OPTIONS
11 # Don't allow CCACHE, if present, to use cached results of compile tests!
12 export CCACHE_RECACHE=yes
14 # make source path absolute
15 source_path=$(cd "$(dirname -- "$0")"; pwd)
17 if test "$PWD" = "$source_path"
18 then
19 echo "Using './build' as the directory for build output"
21 MARKER=build/auto-created-by-configure
23 if test -e build
24 then
25 if test -f $MARKER
26 then
27 rm -rf build
28 else
29 echo "ERROR: ./build dir already exists and was not previously created by configure"
30 exit 1
34 mkdir build
35 touch $MARKER
37 cat > GNUmakefile <<'EOF'
38 # This file is auto-generated by configure to support in-source tree
39 # 'make' command invocation
41 ifeq ($(MAKECMDGOALS),)
42 recurse: all
43 endif
45 .NOTPARALLEL: %
46 %: force
47 @echo 'changing dir to build for $(MAKE) "$(MAKECMDGOALS)"...'
48 @$(MAKE) -C build -f Makefile $(MAKECMDGOALS)
49 @if test "$(MAKECMDGOALS)" = "distclean" && \
50 test -e build/auto-created-by-configure ; \
51 then \
52 rm -rf build GNUmakefile ; \
54 force: ;
55 .PHONY: force
56 GNUmakefile: ;
58 EOF
59 cd build
60 exec "$source_path/configure" "$@"
63 # Temporary directory used for files created while
64 # configure runs. Since it is in the build directory
65 # we can safely blow away any previous version of it
66 # (and we need not jump through hoops to try to delete
67 # it when configure exits.)
68 TMPDIR1="config-temp"
69 rm -rf "${TMPDIR1}"
70 if ! mkdir -p "${TMPDIR1}"; then
71 echo "ERROR: failed to create temporary directory"
72 exit 1
75 TMPB="qemu-conf"
76 TMPC="${TMPDIR1}/${TMPB}.c"
77 TMPO="${TMPDIR1}/${TMPB}.o"
78 TMPM="${TMPDIR1}/${TMPB}.m"
79 TMPE="${TMPDIR1}/${TMPB}.exe"
81 rm -f config.log
83 # Print a helpful header at the top of config.log
84 echo "# QEMU configure log $(date)" >> config.log
85 printf "# Configured with:" >> config.log
86 # repeat the invocation to log and stdout for CI
87 invoke=$(printf " '%s'" "$0" "$@")
88 test -n "$GITLAB_CI" && echo "configuring with: $invoke"
89 { echo "$invoke"; echo; echo "#"; } >> config.log
91 quote_sh() {
92 printf "%s" "$1" | sed "s,','\\\\'',g; s,.*,'&',"
95 print_error() {
96 (echo
97 echo "ERROR: $1"
98 while test -n "$2"; do
99 echo " $2"
100 shift
101 done
102 echo) >&2
105 error_exit() {
106 print_error "$@"
107 exit 1
110 do_compiler() {
111 # Run the compiler, capturing its output to the log. First argument
112 # is compiler binary to execute.
113 compiler="$1"
114 shift
115 if test -n "$BASH_VERSION"; then eval '
116 echo >>config.log "
117 funcs: ${FUNCNAME[*]}
118 lines: ${BASH_LINENO[*]}"
119 '; fi
120 echo $compiler "$@" >> config.log
121 $compiler "$@" >> config.log 2>&1 || return $?
124 do_compiler_werror() {
125 # Run the compiler, capturing its output to the log. First argument
126 # is compiler binary to execute.
127 compiler="$1"
128 shift
129 if test -n "$BASH_VERSION"; then eval '
130 echo >>config.log "
131 funcs: ${FUNCNAME[*]}
132 lines: ${BASH_LINENO[*]}"
133 '; fi
134 echo $compiler "$@" >> config.log
135 $compiler "$@" >> config.log 2>&1 || return $?
136 # Test passed. If this is an --enable-werror build, rerun
137 # the test with -Werror and bail out if it fails. This
138 # makes warning-generating-errors in configure test code
139 # obvious to developers.
140 if test "$werror" != "yes"; then
141 return 0
143 # Don't bother rerunning the compile if we were already using -Werror
144 case "$*" in
145 *-Werror*)
146 return 0
148 esac
149 echo $compiler -Werror "$@" >> config.log
150 $compiler -Werror "$@" >> config.log 2>&1 && return $?
151 error_exit "configure test passed without -Werror but failed with -Werror." \
152 "This is probably a bug in the configure script. The failing command" \
153 "will be at the bottom of config.log." \
154 "You can run configure with --disable-werror to bypass this check."
157 do_cc() {
158 do_compiler_werror "$cc" $CPU_CFLAGS "$@"
161 do_objc() {
162 do_compiler_werror "$objcc" $CPU_CFLAGS "$@"
165 # Append $2 to the variable named $1, with space separation
166 add_to() {
167 eval $1=\${$1:+\"\$$1 \"}\$2
170 compile_object() {
171 local_cflags="$1"
172 do_cc $CFLAGS $EXTRA_CFLAGS $CONFIGURE_CFLAGS $QEMU_CFLAGS $local_cflags -c -o $TMPO $TMPC
175 compile_prog() {
176 local_cflags="$1"
177 local_ldflags="$2"
178 do_cc $CFLAGS $EXTRA_CFLAGS $CONFIGURE_CFLAGS $QEMU_CFLAGS $local_cflags -o $TMPE $TMPC \
179 $LDFLAGS $EXTRA_LDFLAGS $CONFIGURE_LDFLAGS $QEMU_LDFLAGS $local_ldflags
182 # symbolically link $1 to $2. Portable version of "ln -sf".
183 symlink() {
184 rm -rf "$2"
185 mkdir -p "$(dirname "$2")"
186 ln -s "$1" "$2"
189 # check whether a command is available to this shell (may be either an
190 # executable or a builtin)
191 has() {
192 type "$1" >/dev/null 2>&1
195 version_ge () {
196 local_ver1=$(expr "$1" : '\([0-9.]*\)' | tr . ' ')
197 local_ver2=$(echo "$2" | tr . ' ')
198 while true; do
199 set x $local_ver1
200 local_first=${2-0}
201 # 'shift 2' if $2 is set, or 'shift' if $2 is not set
202 shift ${2:+2}
203 local_ver1=$*
204 set x $local_ver2
205 # the second argument finished, the first must be greater or equal
206 test $# = 1 && return 0
207 test $local_first -lt $2 && return 1
208 test $local_first -gt $2 && return 0
209 shift ${2:+2}
210 local_ver2=$*
211 done
214 glob() {
215 eval test -z '"${1#'"$2"'}"'
218 if printf %s\\n "$source_path" "$PWD" | grep -q "[[:space:]:]";
219 then
220 error_exit "main directory cannot contain spaces nor colons"
223 # default parameters
224 cpu=""
225 static="no"
226 cross_compile="no"
227 cross_prefix=""
228 host_cc="cc"
229 stack_protector=""
230 safe_stack=""
231 use_containers="yes"
232 gdb_bin=$(command -v "gdb-multiarch" || command -v "gdb")
234 if test -e "$source_path/.git"
235 then
236 git_submodules_action="update"
237 else
238 git_submodules_action="ignore"
241 git_submodules="ui/keycodemapdb"
242 git="git"
244 # Don't accept a target_list environment variable.
245 unset target_list
246 unset target_list_exclude
248 # Default value for a variable defining feature "foo".
249 # * foo="no" feature will only be used if --enable-foo arg is given
250 # * foo="" feature will be searched for, and if found, will be used
251 # unless --disable-foo is given
252 # * foo="yes" this value will only be set by --enable-foo flag.
253 # feature will searched for,
254 # if not found, configure exits with error
256 # Always add --enable-foo and --disable-foo command line args.
257 # Distributions want to ensure that several features are compiled in, and it
258 # is impossible without a --enable-foo that exits if a feature is not found.
260 default_feature=""
261 # parse CC options second
262 for opt do
263 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
264 case "$opt" in
265 --without-default-features)
266 default_feature="no"
268 esac
269 done
271 EXTRA_CFLAGS=""
272 EXTRA_CXXFLAGS=""
273 EXTRA_OBJCFLAGS=""
274 EXTRA_LDFLAGS=""
276 debug_tcg="no"
277 sanitizers="no"
278 tsan="no"
279 fortify_source="yes"
280 EXESUF=""
281 modules="no"
282 prefix="/usr/local"
283 qemu_suffix="qemu"
284 softmmu="yes"
285 linux_user=""
286 bsd_user=""
287 pie=""
288 coroutine=""
289 plugins="$default_feature"
290 meson=""
291 ninja=""
292 bindir="bin"
293 skip_meson=no
294 vfio_user_server="disabled"
296 # The following Meson options are handled manually (still they
297 # are included in the automatically generated help message)
299 # 1. Track which submodules are needed
300 fdt="auto"
302 # 2. Automatically enable/disable other options
303 tcg="auto"
304 cfi="false"
306 # parse CC options second
307 for opt do
308 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
309 case "$opt" in
310 --cross-prefix=*) cross_prefix="$optarg"
311 cross_compile="yes"
313 --cc=*) CC="$optarg"
315 --cxx=*) CXX="$optarg"
317 --cpu=*) cpu="$optarg"
319 --extra-cflags=*)
320 EXTRA_CFLAGS="$EXTRA_CFLAGS $optarg"
321 EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
322 EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
324 --extra-cxxflags=*) EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
326 --extra-objcflags=*) EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
328 --extra-ldflags=*) EXTRA_LDFLAGS="$EXTRA_LDFLAGS $optarg"
330 --cross-cc-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-cc-FOO option"
332 --cross-cc-cflags-*) cc_arch=${opt#--cross-cc-cflags-}; cc_arch=${cc_arch%%=*}
333 eval "cross_cc_cflags_${cc_arch}=\$optarg"
335 --cross-cc-*) cc_arch=${opt#--cross-cc-}; cc_arch=${cc_arch%%=*}
336 eval "cross_cc_${cc_arch}=\$optarg"
338 --cross-prefix-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-prefix-FOO option"
340 --cross-prefix-*) cc_arch=${opt#--cross-prefix-}; cc_arch=${cc_arch%%=*}
341 eval "cross_prefix_${cc_arch}=\$optarg"
343 esac
344 done
345 # OS specific
346 # Using uname is really, really broken. Once we have the right set of checks
347 # we can eliminate its usage altogether.
349 # Preferred compiler:
350 # ${CC} (if set)
351 # ${cross_prefix}gcc (if cross-prefix specified)
352 # system compiler
353 if test -z "${CC}${cross_prefix}"; then
354 cc="$host_cc"
355 else
356 cc="${CC-${cross_prefix}gcc}"
359 if test -z "${CXX}${cross_prefix}"; then
360 cxx="c++"
361 else
362 cxx="${CXX-${cross_prefix}g++}"
365 ar="${AR-${cross_prefix}ar}"
366 as="${AS-${cross_prefix}as}"
367 ccas="${CCAS-$cc}"
368 objcopy="${OBJCOPY-${cross_prefix}objcopy}"
369 ld="${LD-${cross_prefix}ld}"
370 ranlib="${RANLIB-${cross_prefix}ranlib}"
371 nm="${NM-${cross_prefix}nm}"
372 smbd="$SMBD"
373 strip="${STRIP-${cross_prefix}strip}"
374 widl="${WIDL-${cross_prefix}widl}"
375 windres="${WINDRES-${cross_prefix}windres}"
376 windmc="${WINDMC-${cross_prefix}windmc}"
377 pkg_config_exe="${PKG_CONFIG-${cross_prefix}pkg-config}"
378 query_pkg_config() {
379 "${pkg_config_exe}" ${QEMU_PKG_CONFIG_FLAGS} "$@"
381 pkg_config=query_pkg_config
382 sdl2_config="${SDL2_CONFIG-${cross_prefix}sdl2-config}"
384 # default flags for all hosts
385 # We use -fwrapv to tell the compiler that we require a C dialect where
386 # left shift of signed integers is well defined and has the expected
387 # 2s-complement style results. (Both clang and gcc agree that it
388 # provides these semantics.)
389 QEMU_CFLAGS="-fno-strict-aliasing -fno-common -fwrapv"
390 QEMU_CFLAGS="-Wundef -Wwrite-strings -Wmissing-prototypes $QEMU_CFLAGS"
391 QEMU_CFLAGS="-Wstrict-prototypes -Wredundant-decls $QEMU_CFLAGS"
392 QEMU_CFLAGS="-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE $QEMU_CFLAGS"
394 QEMU_LDFLAGS=
396 # Flags that are needed during configure but later taken care of by Meson
397 CONFIGURE_CFLAGS="-std=gnu11 -Wall"
398 CONFIGURE_LDFLAGS=
401 check_define() {
402 cat > $TMPC <<EOF
403 #if !defined($1)
404 #error $1 not defined
405 #endif
406 int main(void) { return 0; }
408 compile_object
411 check_include() {
412 cat > $TMPC <<EOF
413 #include <$1>
414 int main(void) { return 0; }
416 compile_object
419 write_c_skeleton() {
420 cat > $TMPC <<EOF
421 int main(void) { return 0; }
425 if check_define __linux__ ; then
426 targetos=linux
427 elif check_define _WIN32 ; then
428 targetos=windows
429 elif check_define __OpenBSD__ ; then
430 targetos=openbsd
431 elif check_define __sun__ ; then
432 targetos=sunos
433 elif check_define __HAIKU__ ; then
434 targetos=haiku
435 elif check_define __FreeBSD__ ; then
436 targetos=freebsd
437 elif check_define __FreeBSD_kernel__ && check_define __GLIBC__; then
438 targetos=gnu/kfreebsd
439 elif check_define __DragonFly__ ; then
440 targetos=dragonfly
441 elif check_define __NetBSD__; then
442 targetos=netbsd
443 elif check_define __APPLE__; then
444 targetos=darwin
445 else
446 # This is a fatal error, but don't report it yet, because we
447 # might be going to just print the --help text, or it might
448 # be the result of a missing compiler.
449 targetos=bogus
452 # OS specific
454 mingw32="no"
455 bsd="no"
456 linux="no"
457 solaris="no"
458 case $targetos in
459 windows)
460 mingw32="yes"
461 plugins="no"
462 pie="no"
464 gnu/kfreebsd)
465 bsd="yes"
467 freebsd)
468 bsd="yes"
469 make="${MAKE-gmake}"
470 # needed for kinfo_getvmmap(3) in libutil.h
472 dragonfly)
473 bsd="yes"
474 make="${MAKE-gmake}"
476 netbsd)
477 bsd="yes"
478 make="${MAKE-gmake}"
480 openbsd)
481 bsd="yes"
482 make="${MAKE-gmake}"
484 darwin)
485 bsd="yes"
486 darwin="yes"
487 # Disable attempts to use ObjectiveC features in os/object.h since they
488 # won't work when we're compiling with gcc as a C compiler.
489 QEMU_CFLAGS="-DOS_OBJECT_USE_OBJC=0 $QEMU_CFLAGS"
491 sunos)
492 solaris="yes"
493 make="${MAKE-gmake}"
494 # needed for CMSG_ macros in sys/socket.h
495 QEMU_CFLAGS="-D_XOPEN_SOURCE=600 $QEMU_CFLAGS"
496 # needed for TIOCWIN* defines in termios.h
497 QEMU_CFLAGS="-D__EXTENSIONS__ $QEMU_CFLAGS"
498 # $(uname -m) returns i86pc even on an x86_64 box, so default based on isainfo
499 # Note that this check is broken for cross-compilation: if you're
500 # cross-compiling to one of these OSes then you'll need to specify
501 # the correct CPU with the --cpu option.
502 if test -z "$cpu" && test "$(isainfo -k)" = "amd64"; then
503 cpu="x86_64"
506 haiku)
507 pie="no"
508 QEMU_CFLAGS="-DB_USE_POSITIVE_POSIX_ERRORS -D_BSD_SOURCE -fPIC $QEMU_CFLAGS"
510 linux)
511 linux="yes"
513 esac
515 if test ! -z "$cpu" ; then
516 # command line argument
518 elif check_define __i386__ ; then
519 cpu="i386"
520 elif check_define __x86_64__ ; then
521 if check_define __ILP32__ ; then
522 cpu="x32"
523 else
524 cpu="x86_64"
526 elif check_define __sparc__ ; then
527 if check_define __arch64__ ; then
528 cpu="sparc64"
529 else
530 cpu="sparc"
532 elif check_define _ARCH_PPC ; then
533 if check_define _ARCH_PPC64 ; then
534 if check_define _LITTLE_ENDIAN ; then
535 cpu="ppc64le"
536 else
537 cpu="ppc64"
539 else
540 cpu="ppc"
542 elif check_define __mips__ ; then
543 cpu="mips"
544 elif check_define __s390__ ; then
545 if check_define __s390x__ ; then
546 cpu="s390x"
547 else
548 cpu="s390"
550 elif check_define __riscv ; then
551 cpu="riscv"
552 elif check_define __arm__ ; then
553 cpu="arm"
554 elif check_define __aarch64__ ; then
555 cpu="aarch64"
556 elif check_define __loongarch64 ; then
557 cpu="loongarch64"
558 else
559 cpu=$(uname -m)
562 # Normalise host CPU name, set multilib cflags
563 # Note that this case should only have supported host CPUs, not guests.
564 case "$cpu" in
565 armv*b|armv*l|arm)
566 cpu="arm" ;;
568 i386|i486|i586|i686|i86pc|BePC)
569 cpu="i386"
570 CPU_CFLAGS="-m32" ;;
571 x32)
572 cpu="x86_64"
573 CPU_CFLAGS="-mx32" ;;
574 x86_64|amd64)
575 cpu="x86_64"
576 # ??? Only extremely old AMD cpus do not have cmpxchg16b.
577 # If we truly care, we should simply detect this case at
578 # runtime and generate the fallback to serial emulation.
579 CPU_CFLAGS="-m64 -mcx16" ;;
581 mips*)
582 cpu="mips" ;;
584 ppc)
585 CPU_CFLAGS="-m32" ;;
586 ppc64)
587 CPU_CFLAGS="-m64 -mbig-endian" ;;
588 ppc64le)
589 cpu="ppc64"
590 CPU_CFLAGS="-m64 -mlittle-endian" ;;
592 s390)
593 CPU_CFLAGS="-m31" ;;
594 s390x)
595 CPU_CFLAGS="-m64" ;;
597 sparc|sun4[cdmuv])
598 cpu="sparc"
599 CPU_CFLAGS="-m32 -mv8plus -mcpu=ultrasparc" ;;
600 sparc64)
601 CPU_CFLAGS="-m64 -mcpu=ultrasparc" ;;
602 esac
604 : ${make=${MAKE-make}}
606 # We prefer python 3.x. A bare 'python' is traditionally
607 # python 2.x, but some distros have it as python 3.x, so
608 # we check that too
609 python=
610 explicit_python=no
611 for binary in "${PYTHON-python3}" python
613 if has "$binary"
614 then
615 python=$(command -v "$binary")
616 break
618 done
621 # Check for ancillary tools used in testing
622 genisoimage=
623 for binary in genisoimage mkisofs
625 if has $binary
626 then
627 genisoimage=$(command -v "$binary")
628 break
630 done
632 # Default objcc to clang if available, otherwise use CC
633 if has clang; then
634 objcc=clang
635 else
636 objcc="$cc"
639 if test "$mingw32" = "yes" ; then
640 EXESUF=".exe"
641 # MinGW needs -mthreads for TLS and macro _MT.
642 CONFIGURE_CFLAGS="-mthreads $CONFIGURE_CFLAGS"
643 write_c_skeleton;
644 prefix="/qemu"
645 bindir=""
646 qemu_suffix=""
649 werror=""
651 meson_option_build_array() {
652 printf '['
653 (if test "$targetos" = windows; then
654 IFS=\;
655 else
656 IFS=:
658 for e in $1; do
659 printf '"""'
660 # backslash escape any '\' and '"' characters
661 printf "%s" "$e" | sed -e 's/\([\"]\)/\\\1/g'
662 printf '""",'
663 done)
664 printf ']\n'
667 . "$source_path/scripts/meson-buildoptions.sh"
669 meson_options=
670 meson_option_add() {
671 meson_options="$meson_options $(quote_sh "$1")"
673 meson_option_parse() {
674 meson_options="$meson_options $(_meson_option_parse "$@")"
675 if test $? -eq 1; then
676 echo "ERROR: unknown option $1"
677 echo "Try '$0 --help' for more information"
678 exit 1
682 for opt do
683 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
684 case "$opt" in
685 --help|-h) show_help=yes
687 --version|-V) exec cat "$source_path/VERSION"
689 --prefix=*) prefix="$optarg"
691 --cross-prefix=*)
693 --cc=*)
695 --host-cc=*) host_cc="$optarg"
697 --cxx=*)
699 --objcc=*) objcc="$optarg"
701 --make=*) make="$optarg"
703 --install=*)
705 --python=*) python="$optarg" ; explicit_python=yes
707 --skip-meson) skip_meson=yes
709 --meson=*) meson="$optarg"
711 --ninja=*) ninja="$optarg"
713 --smbd=*) smbd="$optarg"
715 --extra-cflags=*)
717 --extra-cxxflags=*)
719 --extra-objcflags=*)
721 --extra-ldflags=*)
723 --cross-cc-*)
725 --cross-prefix-*)
727 --enable-debug-info) meson_option_add -Ddebug=true
729 --disable-debug-info) meson_option_add -Ddebug=false
731 --enable-modules)
732 modules="yes"
734 --disable-modules)
735 modules="no"
737 --cpu=*)
739 --target-list=*) target_list="$optarg"
740 if test "$target_list_exclude"; then
741 error_exit "Can't mix --target-list with --target-list-exclude"
744 --target-list-exclude=*) target_list_exclude="$optarg"
745 if test "$target_list"; then
746 error_exit "Can't mix --target-list-exclude with --target-list"
749 --with-default-devices) meson_option_add -Ddefault_devices=true
751 --without-default-devices) meson_option_add -Ddefault_devices=false
753 --with-devices-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --with-devices-FOO option"
755 --with-devices-*) device_arch=${opt#--with-devices-};
756 device_arch=${device_arch%%=*}
757 cf=$source_path/configs/devices/$device_arch-softmmu/$optarg.mak
758 if test -f "$cf"; then
759 device_archs="$device_archs $device_arch"
760 eval "devices_${device_arch}=\$optarg"
761 else
762 error_exit "File $cf does not exist"
765 --without-default-features) # processed above
767 --static)
768 static="yes"
769 QEMU_PKG_CONFIG_FLAGS="--static $QEMU_PKG_CONFIG_FLAGS"
771 --bindir=*) bindir="$optarg"
773 --with-suffix=*) qemu_suffix="$optarg"
775 --host=*|--build=*|\
776 --disable-dependency-tracking|\
777 --sbindir=*|--sharedstatedir=*|\
778 --oldincludedir=*|--datarootdir=*|--infodir=*|\
779 --htmldir=*|--dvidir=*|--pdfdir=*|--psdir=*)
780 # These switches are silently ignored, for compatibility with
781 # autoconf-generated configure scripts. This allows QEMU's
782 # configure to be used by RPM and similar macros that set
783 # lots of directory switches by default.
785 --enable-debug-tcg) debug_tcg="yes"
787 --disable-debug-tcg) debug_tcg="no"
789 --enable-debug)
790 # Enable debugging options that aren't excessively noisy
791 debug_tcg="yes"
792 meson_option_parse --enable-debug-mutex ""
793 meson_option_add -Doptimization=0
794 fortify_source="no"
796 --enable-sanitizers) sanitizers="yes"
798 --disable-sanitizers) sanitizers="no"
800 --enable-tsan) tsan="yes"
802 --disable-tsan) tsan="no"
804 --disable-tcg) tcg="disabled"
805 plugins="no"
807 --enable-tcg) tcg="enabled"
809 --disable-system) softmmu="no"
811 --enable-system) softmmu="yes"
813 --disable-user)
814 linux_user="no" ;
815 bsd_user="no" ;
817 --enable-user) ;;
818 --disable-linux-user) linux_user="no"
820 --enable-linux-user) linux_user="yes"
822 --disable-bsd-user) bsd_user="no"
824 --enable-bsd-user) bsd_user="yes"
826 --enable-pie) pie="yes"
828 --disable-pie) pie="no"
830 --enable-werror) werror="yes"
832 --disable-werror) werror="no"
834 --enable-stack-protector) stack_protector="yes"
836 --disable-stack-protector) stack_protector="no"
838 --enable-safe-stack) safe_stack="yes"
840 --disable-safe-stack) safe_stack="no"
842 --enable-cfi)
843 cfi="true";
844 meson_option_add -Db_lto=true
846 --disable-cfi) cfi="false"
848 --disable-fdt) fdt="disabled"
850 --enable-fdt) fdt="enabled"
852 --enable-fdt=git) fdt="internal"
854 --enable-fdt=*) fdt="$optarg"
856 --with-coroutine=*) coroutine="$optarg"
858 --disable-zlib-test)
860 --disable-virtio-blk-data-plane|--enable-virtio-blk-data-plane)
861 echo "$0: $opt is obsolete, virtio-blk data-plane is always on" >&2
863 --enable-vhdx|--disable-vhdx)
864 echo "$0: $opt is obsolete, VHDX driver is always built" >&2
866 --enable-uuid|--disable-uuid)
867 echo "$0: $opt is obsolete, UUID support is always built" >&2
869 --with-git=*) git="$optarg"
871 --with-git-submodules=*)
872 git_submodules_action="$optarg"
874 --enable-plugins) if test "$mingw32" = "yes"; then
875 error_exit "TCG plugins not currently supported on Windows platforms"
876 else
877 plugins="yes"
880 --disable-plugins) plugins="no"
882 --enable-containers) use_containers="yes"
884 --disable-containers) use_containers="no"
886 --gdb=*) gdb_bin="$optarg"
888 # backwards compatibility options
889 --enable-trace-backend=*) meson_option_parse "--enable-trace-backends=$optarg" "$optarg"
891 --disable-blobs) meson_option_parse --disable-install-blobs ""
893 --enable-vfio-user-server) vfio_user_server="enabled"
895 --disable-vfio-user-server) vfio_user_server="disabled"
897 --enable-tcmalloc) meson_option_parse --enable-malloc=tcmalloc tcmalloc
899 --enable-jemalloc) meson_option_parse --enable-malloc=jemalloc jemalloc
901 # everything else has the same name in configure and meson
902 --*) meson_option_parse "$opt" "$optarg"
904 esac
905 done
907 # test for any invalid configuration combinations
908 if test "$plugins" = "yes" -a "$tcg" = "disabled"; then
909 error_exit "Can't enable plugins on non-TCG builds"
912 case $git_submodules_action in
913 update|validate)
914 if test ! -e "$source_path/.git"; then
915 echo "ERROR: cannot $git_submodules_action git submodules without .git"
916 exit 1
919 ignore)
920 if ! test -f "$source_path/ui/keycodemapdb/README"
921 then
922 echo
923 echo "ERROR: missing GIT submodules"
924 echo
925 if test -e "$source_path/.git"; then
926 echo "--with-git-submodules=ignore specified but submodules were not"
927 echo "checked out. Please initialize and update submodules."
928 else
929 echo "This is not a GIT checkout but module content appears to"
930 echo "be missing. Do not use 'git archive' or GitHub download links"
931 echo "to acquire QEMU source archives. Non-GIT builds are only"
932 echo "supported with source archives linked from:"
933 echo
934 echo " https://www.qemu.org/download/#source"
935 echo
936 echo "Developers working with GIT can use scripts/archive-source.sh"
937 echo "if they need to create valid source archives."
939 echo
940 exit 1
944 echo "ERROR: invalid --with-git-submodules= value '$git_submodules_action'"
945 exit 1
947 esac
949 default_target_list=""
950 mak_wilds=""
952 if [ "$linux_user" != no ]; then
953 if [ "$targetos" = linux ] && [ -d "$source_path/linux-user/include/host/$cpu" ]; then
954 linux_user=yes
955 elif [ "$linux_user" = yes ]; then
956 error_exit "linux-user not supported on this architecture"
959 if [ "$bsd_user" != no ]; then
960 if [ "$bsd_user" = "" ]; then
961 test $targetos = freebsd && bsd_user=yes
963 if [ "$bsd_user" = yes ] && ! [ -d "$source_path/bsd-user/$targetos" ]; then
964 error_exit "bsd-user not supported on this host OS"
967 if [ "$softmmu" = "yes" ]; then
968 mak_wilds="${mak_wilds} $source_path/configs/targets/*-softmmu.mak"
970 if [ "$linux_user" = "yes" ]; then
971 mak_wilds="${mak_wilds} $source_path/configs/targets/*-linux-user.mak"
973 if [ "$bsd_user" = "yes" ]; then
974 mak_wilds="${mak_wilds} $source_path/configs/targets/*-bsd-user.mak"
977 for config in $mak_wilds; do
978 target="$(basename "$config" .mak)"
979 if echo "$target_list_exclude" | grep -vq "$target"; then
980 default_target_list="${default_target_list} $target"
982 done
984 if test x"$show_help" = x"yes" ; then
985 cat << EOF
987 Usage: configure [options]
988 Options: [defaults in brackets after descriptions]
990 Standard options:
991 --help print this message
992 --prefix=PREFIX install in PREFIX [$prefix]
993 --target-list=LIST set target list (default: build all)
994 $(echo Available targets: $default_target_list | \
995 fold -s -w 53 | sed -e 's/^/ /')
996 --target-list-exclude=LIST exclude a set of targets from the default target-list
998 Advanced options (experts only):
999 --cross-prefix=PREFIX use PREFIX for compile tools, PREFIX can be blank [$cross_prefix]
1000 --cc=CC use C compiler CC [$cc]
1001 --host-cc=CC use C compiler CC [$host_cc] for code run at
1002 build time
1003 --cxx=CXX use C++ compiler CXX [$cxx]
1004 --objcc=OBJCC use Objective-C compiler OBJCC [$objcc]
1005 --extra-cflags=CFLAGS append extra C compiler flags CFLAGS
1006 --extra-cxxflags=CXXFLAGS append extra C++ compiler flags CXXFLAGS
1007 --extra-objcflags=OBJCFLAGS append extra Objective C compiler flags OBJCFLAGS
1008 --extra-ldflags=LDFLAGS append extra linker flags LDFLAGS
1009 --cross-cc-ARCH=CC use compiler when building ARCH guest test cases
1010 --cross-cc-cflags-ARCH= use compiler flags when building ARCH guest tests
1011 --cross-prefix-ARCH=PREFIX cross compiler prefix when building ARCH guest test cases
1012 --make=MAKE use specified make [$make]
1013 --python=PYTHON use specified python [$python]
1014 --meson=MESON use specified meson [$meson]
1015 --ninja=NINJA use specified ninja [$ninja]
1016 --smbd=SMBD use specified smbd [$smbd]
1017 --with-git=GIT use specified git [$git]
1018 --with-git-submodules=update update git submodules (default if .git dir exists)
1019 --with-git-submodules=validate fail if git submodules are not up to date
1020 --with-git-submodules=ignore do not update or check git submodules (default if no .git dir)
1021 --static enable static build [$static]
1022 --bindir=PATH install binaries in PATH
1023 --with-suffix=SUFFIX suffix for QEMU data inside datadir/libdir/sysconfdir/docdir [$qemu_suffix]
1024 --without-default-features default all --enable-* options to "disabled"
1025 --without-default-devices do not include any device that is not needed to
1026 start the emulator (only use if you are including
1027 desired devices in configs/devices/)
1028 --with-devices-ARCH=NAME override default configs/devices
1029 --enable-debug enable common debug build options
1030 --enable-sanitizers enable default sanitizers
1031 --enable-tsan enable thread sanitizer
1032 --disable-werror disable compilation abort on warning
1033 --disable-stack-protector disable compiler-provided stack protection
1034 --cpu=CPU Build for host CPU [$cpu]
1035 --with-coroutine=BACKEND coroutine backend. Supported options:
1036 ucontext, sigaltstack, windows
1037 --enable-plugins
1038 enable plugins via shared library loading
1039 --disable-containers don't use containers for cross-building
1040 --gdb=GDB-path gdb to use for gdbstub tests [$gdb_bin]
1042 meson_options_help
1043 cat << EOF
1044 system all system emulation targets
1045 user supported user emulation targets
1046 linux-user all linux usermode emulation targets
1047 bsd-user all BSD usermode emulation targets
1048 pie Position Independent Executables
1049 modules modules support (non-Windows)
1050 debug-tcg TCG debugging (default is disabled)
1051 debug-info debugging information
1052 safe-stack SafeStack Stack Smash Protection. Depends on
1053 clang/llvm >= 3.7 and requires coroutine backend ucontext.
1055 NOTE: The object files are built at the place where configure is launched
1057 exit 0
1060 # Remove old dependency files to make sure that they get properly regenerated
1061 rm -f ./*/config-devices.mak.d
1063 if test -z "$python"
1064 then
1065 error_exit "Python not found. Use --python=/path/to/python"
1067 if ! has "$make"
1068 then
1069 error_exit "GNU make ($make) not found"
1072 # Note that if the Python conditional here evaluates True we will exit
1073 # with status 1 which is a shell 'false' value.
1074 if ! $python -c 'import sys; sys.exit(sys.version_info < (3,6))'; then
1075 error_exit "Cannot use '$python', Python >= 3.6 is required." \
1076 "Use --python=/path/to/python to specify a supported Python."
1079 # Suppress writing compiled files
1080 python="$python -B"
1082 if test -z "$meson"; then
1083 if test "$explicit_python" = no && has meson && version_ge "$(meson --version)" 0.61.5; then
1084 meson=meson
1085 elif test "$git_submodules_action" != 'ignore' ; then
1086 meson=git
1087 elif test -e "${source_path}/meson/meson.py" ; then
1088 meson=internal
1089 else
1090 if test "$explicit_python" = yes; then
1091 error_exit "--python requires using QEMU's embedded Meson distribution, but it was not found."
1092 else
1093 error_exit "Meson not found. Use --meson=/path/to/meson"
1096 else
1097 # Meson uses its own Python interpreter to invoke other Python scripts,
1098 # but the user wants to use the one they specified with --python.
1100 # We do not want to override the distro Python interpreter (and sometimes
1101 # cannot: for example in Homebrew /usr/bin/meson is a bash script), so
1102 # just require --meson=git|internal together with --python.
1103 if test "$explicit_python" = yes; then
1104 case "$meson" in
1105 git | internal) ;;
1106 *) error_exit "--python requires using QEMU's embedded Meson distribution." ;;
1107 esac
1111 if test "$meson" = git; then
1112 git_submodules="${git_submodules} meson"
1115 case "$meson" in
1116 git | internal)
1117 meson="$python ${source_path}/meson/meson.py"
1119 *) meson=$(command -v "$meson") ;;
1120 esac
1122 # Probe for ninja
1124 if test -z "$ninja"; then
1125 for c in ninja ninja-build samu; do
1126 if has $c; then
1127 ninja=$(command -v "$c")
1128 break
1130 done
1131 if test -z "$ninja"; then
1132 error_exit "Cannot find Ninja"
1136 # Check that the C compiler works. Doing this here before testing
1137 # the host CPU ensures that we had a valid CC to autodetect the
1138 # $cpu var (and we should bail right here if that's not the case).
1139 # It also allows the help message to be printed without a CC.
1140 write_c_skeleton;
1141 if compile_object ; then
1142 : C compiler works ok
1143 else
1144 error_exit "\"$cc\" either does not exist or does not work"
1146 if ! compile_prog ; then
1147 error_exit "\"$cc\" cannot build an executable (is your linker broken?)"
1150 # Consult white-list to determine whether to enable werror
1151 # by default. Only enable by default for git builds
1152 if test -z "$werror" ; then
1153 if test "$git_submodules_action" != "ignore" && \
1154 { test "$linux" = "yes" || test "$mingw32" = "yes"; }; then
1155 werror="yes"
1156 else
1157 werror="no"
1161 if test "$targetos" = "bogus"; then
1162 # Now that we know that we're not printing the help and that
1163 # the compiler works (so the results of the check_defines we used
1164 # to identify the OS are reliable), if we didn't recognize the
1165 # host OS we should stop now.
1166 error_exit "Unrecognized host OS (uname -s reports '$(uname -s)')"
1169 # Check whether the compiler matches our minimum requirements:
1170 cat > $TMPC << EOF
1171 #if defined(__clang_major__) && defined(__clang_minor__)
1172 # ifdef __apple_build_version__
1173 # if __clang_major__ < 10 || (__clang_major__ == 10 && __clang_minor__ < 0)
1174 # error You need at least XCode Clang v10.0 to compile QEMU
1175 # endif
1176 # else
1177 # if __clang_major__ < 6 || (__clang_major__ == 6 && __clang_minor__ < 0)
1178 # error You need at least Clang v6.0 to compile QEMU
1179 # endif
1180 # endif
1181 #elif defined(__GNUC__) && defined(__GNUC_MINOR__)
1182 # if __GNUC__ < 7 || (__GNUC__ == 7 && __GNUC_MINOR__ < 4)
1183 # error You need at least GCC v7.4.0 to compile QEMU
1184 # endif
1185 #else
1186 # error You either need GCC or Clang to compiler QEMU
1187 #endif
1188 int main (void) { return 0; }
1190 if ! compile_prog "" "" ; then
1191 error_exit "You need at least GCC v7.4 or Clang v6.0 (or XCode Clang v10.0)"
1194 # Accumulate -Wfoo and -Wno-bar separately.
1195 # We will list all of the enable flags first, and the disable flags second.
1196 # Note that we do not add -Werror, because that would enable it for all
1197 # configure tests. If a configure test failed due to -Werror this would
1198 # just silently disable some features, so it's too error prone.
1200 warn_flags=
1201 add_to warn_flags -Wold-style-declaration
1202 add_to warn_flags -Wold-style-definition
1203 add_to warn_flags -Wtype-limits
1204 add_to warn_flags -Wformat-security
1205 add_to warn_flags -Wformat-y2k
1206 add_to warn_flags -Winit-self
1207 add_to warn_flags -Wignored-qualifiers
1208 add_to warn_flags -Wempty-body
1209 add_to warn_flags -Wnested-externs
1210 add_to warn_flags -Wendif-labels
1211 add_to warn_flags -Wexpansion-to-defined
1212 add_to warn_flags -Wimplicit-fallthrough=2
1214 nowarn_flags=
1215 add_to nowarn_flags -Wno-initializer-overrides
1216 add_to nowarn_flags -Wno-missing-include-dirs
1217 add_to nowarn_flags -Wno-shift-negative-value
1218 add_to nowarn_flags -Wno-string-plus-int
1219 add_to nowarn_flags -Wno-typedef-redefinition
1220 add_to nowarn_flags -Wno-tautological-type-limit-compare
1221 add_to nowarn_flags -Wno-psabi
1222 add_to nowarn_flags -Wno-gnu-variable-sized-type-not-at-end
1224 gcc_flags="$warn_flags $nowarn_flags"
1226 cc_has_warning_flag() {
1227 write_c_skeleton;
1229 # Use the positive sense of the flag when testing for -Wno-wombat
1230 # support (gcc will happily accept the -Wno- form of unknown
1231 # warning options).
1232 optflag="$(echo $1 | sed -e 's/^-Wno-/-W/')"
1233 compile_prog "-Werror $optflag" ""
1236 objcc_has_warning_flag() {
1237 cat > $TMPM <<EOF
1238 int main(void) { return 0; }
1241 # Use the positive sense of the flag when testing for -Wno-wombat
1242 # support (gcc will happily accept the -Wno- form of unknown
1243 # warning options).
1244 optflag="$(echo $1 | sed -e 's/^-Wno-/-W/')"
1245 do_objc -Werror $optflag \
1246 $OBJCFLAGS $EXTRA_OBJCFLAGS $CONFIGURE_OBJCFLAGS $QEMU_OBJCFLAGS \
1247 -o $TMPE $TMPM $QEMU_LDFLAGS
1250 for flag in $gcc_flags; do
1251 if cc_has_warning_flag $flag ; then
1252 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1254 if objcc_has_warning_flag $flag ; then
1255 QEMU_OBJCFLAGS="$QEMU_OBJCFLAGS $flag"
1257 done
1259 if test "$stack_protector" != "no"; then
1260 cat > $TMPC << EOF
1261 int main(int argc, char *argv[])
1263 char arr[64], *p = arr, *c = argv[argc - 1];
1264 while (*c) {
1265 *p++ = *c++;
1267 return 0;
1270 gcc_flags="-fstack-protector-strong -fstack-protector-all"
1271 sp_on=0
1272 for flag in $gcc_flags; do
1273 # We need to check both a compile and a link, since some compiler
1274 # setups fail only on a .c->.o compile and some only at link time
1275 if compile_object "-Werror $flag" &&
1276 compile_prog "-Werror $flag" ""; then
1277 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1278 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1279 sp_on=1
1280 break
1282 done
1283 if test "$stack_protector" = yes; then
1284 if test $sp_on = 0; then
1285 error_exit "Stack protector not supported"
1290 # Disable -Wmissing-braces on older compilers that warn even for
1291 # the "universal" C zero initializer {0}.
1292 cat > $TMPC << EOF
1293 struct {
1294 int a[2];
1295 } x = {0};
1297 if compile_object "-Werror" "" ; then
1299 else
1300 QEMU_CFLAGS="$QEMU_CFLAGS -Wno-missing-braces"
1303 # Our module code doesn't support Windows
1304 if test "$modules" = "yes" && test "$mingw32" = "yes" ; then
1305 error_exit "Modules are not available for Windows"
1308 # Static linking is not possible with plugins, modules or PIE
1309 if test "$static" = "yes" ; then
1310 if test "$modules" = "yes" ; then
1311 error_exit "static and modules are mutually incompatible"
1313 if test "$plugins" = "yes"; then
1314 error_exit "static and plugins are mutually incompatible"
1315 else
1316 plugins="no"
1319 test "$plugins" = "" && plugins=yes
1321 cat > $TMPC << EOF
1323 #ifdef __linux__
1324 # define THREAD __thread
1325 #else
1326 # define THREAD
1327 #endif
1328 static THREAD int tls_var;
1329 int main(void) { return tls_var; }
1332 # Meson currently only handles pie as a boolean for now so if we have
1333 # explicitly disabled PIE we need to extend our cflags because it wont.
1334 if test "$static" = "yes"; then
1335 if test "$pie" != "no" && compile_prog "-Werror -fPIE -DPIE" "-static-pie"; then
1336 CONFIGURE_CFLAGS="-fPIE -DPIE $CONFIGURE_CFLAGS"
1337 pie="yes"
1338 elif test "$pie" = "yes"; then
1339 error_exit "-static-pie not available due to missing toolchain support"
1340 else
1341 pie="no"
1342 QEMU_CFLAGS="-fno-pie -no-pie $QEMU_CFLAGS"
1344 elif test "$pie" = "no"; then
1345 if compile_prog "-Werror -fno-pie" "-no-pie"; then
1346 CONFIGURE_CFLAGS="-fno-pie $CONFIGURE_CFLAGS"
1347 CONFIGURE_LDFLAGS="-no-pie $CONFIGURE_LDFLAGS"
1348 QEMU_CFLAGS="-fno-pie -no-pie $QEMU_CFLAGS"
1350 elif compile_prog "-Werror -fPIE -DPIE" "-pie"; then
1351 CONFIGURE_CFLAGS="-fPIE -DPIE $CONFIGURE_CFLAGS"
1352 CONFIGURE_LDFLAGS="-pie $CONFIGURE_LDFLAGS"
1353 pie="yes"
1354 elif test "$pie" = "yes"; then
1355 error_exit "PIE not available due to missing toolchain support"
1356 else
1357 echo "Disabling PIE due to missing toolchain support"
1358 pie="no"
1361 ##########################################
1362 # __sync_fetch_and_and requires at least -march=i486. Many toolchains
1363 # use i686 as default anyway, but for those that don't, an explicit
1364 # specification is necessary
1366 if test "$cpu" = "i386"; then
1367 cat > $TMPC << EOF
1368 static int sfaa(int *ptr)
1370 return __sync_fetch_and_and(ptr, 0);
1373 int main(void)
1375 int val = 42;
1376 val = __sync_val_compare_and_swap(&val, 0, 1);
1377 sfaa(&val);
1378 return val;
1381 if ! compile_prog "" "" ; then
1382 QEMU_CFLAGS="-march=i486 $QEMU_CFLAGS"
1386 if test -z "${target_list+xxx}" ; then
1387 default_targets=yes
1388 for target in $default_target_list; do
1389 target_list="$target_list $target"
1390 done
1391 target_list="${target_list# }"
1392 else
1393 default_targets=no
1394 target_list=$(echo "$target_list" | sed -e 's/,/ /g')
1395 for target in $target_list; do
1396 # Check that we recognised the target name; this allows a more
1397 # friendly error message than if we let it fall through.
1398 case " $default_target_list " in
1399 *" $target "*)
1402 error_exit "Unknown target name '$target'"
1404 esac
1405 done
1408 # see if system emulation was really requested
1409 case " $target_list " in
1410 *"-softmmu "*) softmmu=yes
1412 *) softmmu=no
1414 esac
1416 if test "$tcg" = "auto"; then
1417 if test -z "$target_list"; then
1418 tcg="disabled"
1419 else
1420 tcg="enabled"
1424 if test "$tcg" = "enabled"; then
1425 git_submodules="$git_submodules tests/fp/berkeley-testfloat-3"
1426 git_submodules="$git_submodules tests/fp/berkeley-softfloat-3"
1429 ##########################################
1430 # big/little endian test
1431 cat > $TMPC << EOF
1432 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
1433 # error LITTLE
1434 #endif
1435 int main(void) { return 0; }
1438 if ! compile_prog ; then
1439 bigendian="no"
1440 else
1441 cat > $TMPC << EOF
1442 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
1443 # error BIG
1444 #endif
1445 int main(void) { return 0; }
1448 if ! compile_prog ; then
1449 bigendian="yes"
1450 else
1451 echo big/little test failed
1452 exit 1
1456 ##########################################
1457 # pkg-config probe
1459 if ! has "$pkg_config_exe"; then
1460 error_exit "pkg-config binary '$pkg_config_exe' not found"
1463 ##########################################
1464 # glib support probe
1466 # When bumping glib_req_ver, please check also whether we should increase
1467 # the _WIN32_WINNT setting in osdep.h according to the value from glib
1468 glib_req_ver=2.56
1469 glib_modules=gthread-2.0
1470 if test "$modules" = yes; then
1471 glib_modules="$glib_modules gmodule-export-2.0"
1472 elif test "$plugins" = "yes"; then
1473 glib_modules="$glib_modules gmodule-no-export-2.0"
1476 for i in $glib_modules; do
1477 if $pkg_config --atleast-version=$glib_req_ver $i; then
1478 glib_cflags=$($pkg_config --cflags $i)
1479 glib_libs=$($pkg_config --libs $i)
1480 else
1481 error_exit "glib-$glib_req_ver $i is required to compile QEMU"
1483 done
1485 glib_bindir="$($pkg_config --variable=bindir glib-2.0)"
1486 if test -z "$glib_bindir" ; then
1487 glib_bindir="$($pkg_config --variable=prefix glib-2.0)"/bin
1490 # This workaround is required due to a bug in pkg-config file for glib as it
1491 # doesn't define GLIB_STATIC_COMPILATION for pkg-config --static
1493 if test "$static" = yes && test "$mingw32" = yes; then
1494 glib_cflags="-DGLIB_STATIC_COMPILATION $glib_cflags"
1497 # Sanity check that the current size_t matches the
1498 # size that glib thinks it should be. This catches
1499 # problems on multi-arch where people try to build
1500 # 32-bit QEMU while pointing at 64-bit glib headers
1501 cat > $TMPC <<EOF
1502 #include <glib.h>
1503 #include <unistd.h>
1505 #define QEMU_BUILD_BUG_ON(x) \
1506 typedef char qemu_build_bug_on[(x)?-1:1] __attribute__((unused));
1508 int main(void) {
1509 QEMU_BUILD_BUG_ON(sizeof(size_t) != GLIB_SIZEOF_SIZE_T);
1510 return 0;
1514 if ! compile_prog "$glib_cflags" "$glib_libs" ; then
1515 error_exit "sizeof(size_t) doesn't match GLIB_SIZEOF_SIZE_T."\
1516 "You probably need to set PKG_CONFIG_LIBDIR"\
1517 "to point to the right pkg-config files for your"\
1518 "build target"
1521 # Silence clang warnings triggered by glib < 2.57.2
1522 cat > $TMPC << EOF
1523 #include <glib.h>
1524 typedef struct Foo {
1525 int i;
1526 } Foo;
1527 static void foo_free(Foo *f)
1529 g_free(f);
1531 G_DEFINE_AUTOPTR_CLEANUP_FUNC(Foo, foo_free)
1532 int main(void) { return 0; }
1534 if ! compile_prog "$glib_cflags -Werror" "$glib_libs" ; then
1535 if cc_has_warning_flag "-Wno-unused-function"; then
1536 glib_cflags="$glib_cflags -Wno-unused-function"
1537 CONFIGURE_CFLAGS="$CONFIGURE_CFLAGS -Wno-unused-function"
1541 ##########################################
1542 # fdt probe
1544 case "$fdt" in
1545 auto | enabled | internal)
1546 # Simpler to always update submodule, even if not needed.
1547 git_submodules="${git_submodules} dtc"
1549 esac
1551 ##########################################
1552 # check and set a backend for coroutine
1554 # We prefer ucontext, but it's not always possible. The fallback
1555 # is sigcontext. On Windows the only valid backend is the Windows
1556 # specific one.
1558 ucontext_works=no
1559 if test "$darwin" != "yes"; then
1560 cat > $TMPC << EOF
1561 #include <ucontext.h>
1562 #ifdef __stub_makecontext
1563 #error Ignoring glibc stub makecontext which will always fail
1564 #endif
1565 int main(void) { makecontext(0, 0, 0); return 0; }
1567 if compile_prog "" "" ; then
1568 ucontext_works=yes
1572 if test "$coroutine" = ""; then
1573 if test "$mingw32" = "yes"; then
1574 coroutine=win32
1575 elif test "$ucontext_works" = "yes"; then
1576 coroutine=ucontext
1577 else
1578 coroutine=sigaltstack
1580 else
1581 case $coroutine in
1582 windows)
1583 if test "$mingw32" != "yes"; then
1584 error_exit "'windows' coroutine backend only valid for Windows"
1586 # Unfortunately the user visible backend name doesn't match the
1587 # coroutine-*.c filename for this case, so we have to adjust it here.
1588 coroutine=win32
1590 ucontext)
1591 if test "$ucontext_works" != "yes"; then
1592 error_exit "'ucontext' backend requested but makecontext not available"
1595 sigaltstack)
1596 if test "$mingw32" = "yes"; then
1597 error_exit "only the 'windows' coroutine backend is valid for Windows"
1601 error_exit "unknown coroutine backend $coroutine"
1603 esac
1606 ##################################################
1607 # SafeStack
1610 if test "$safe_stack" = "yes"; then
1611 cat > $TMPC << EOF
1612 int main(void)
1614 #if ! __has_feature(safe_stack)
1615 #error SafeStack Disabled
1616 #endif
1617 return 0;
1620 flag="-fsanitize=safe-stack"
1621 # Check that safe-stack is supported and enabled.
1622 if compile_prog "-Werror $flag" "$flag"; then
1623 # Flag needed both at compilation and at linking
1624 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1625 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1626 else
1627 error_exit "SafeStack not supported by your compiler"
1629 if test "$coroutine" != "ucontext"; then
1630 error_exit "SafeStack is only supported by the coroutine backend ucontext"
1632 else
1633 cat > $TMPC << EOF
1634 int main(void)
1636 #if defined(__has_feature)
1637 #if __has_feature(safe_stack)
1638 #error SafeStack Enabled
1639 #endif
1640 #endif
1641 return 0;
1644 if test "$safe_stack" = "no"; then
1645 # Make sure that safe-stack is disabled
1646 if ! compile_prog "-Werror" ""; then
1647 # SafeStack was already enabled, try to explicitly remove the feature
1648 flag="-fno-sanitize=safe-stack"
1649 if ! compile_prog "-Werror $flag" "$flag"; then
1650 error_exit "Configure cannot disable SafeStack"
1652 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1653 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1655 else # "$safe_stack" = ""
1656 # Set safe_stack to yes or no based on pre-existing flags
1657 if compile_prog "-Werror" ""; then
1658 safe_stack="no"
1659 else
1660 safe_stack="yes"
1661 if test "$coroutine" != "ucontext"; then
1662 error_exit "SafeStack is only supported by the coroutine backend ucontext"
1668 ########################################
1669 # check if ccache is interfering with
1670 # semantic analysis of macros
1672 unset CCACHE_CPP2
1673 ccache_cpp2=no
1674 cat > $TMPC << EOF
1675 static const int Z = 1;
1676 #define fn() ({ Z; })
1677 #define TAUT(X) ((X) == Z)
1678 #define PAREN(X, Y) (X == Y)
1679 #define ID(X) (X)
1680 int main(void)
1682 int x = 0, y = 0;
1683 x = ID(x);
1684 x = fn();
1685 fn();
1686 if (PAREN(x, y)) return 0;
1687 if (TAUT(Z)) return 0;
1688 return 0;
1692 if ! compile_object "-Werror"; then
1693 ccache_cpp2=yes
1696 #################################################
1697 # clang does not support glibc + FORTIFY_SOURCE.
1699 if test "$fortify_source" != "no"; then
1700 if echo | $cc -dM -E - | grep __clang__ > /dev/null 2>&1 ; then
1701 fortify_source="no";
1702 elif test -n "$cxx" && has $cxx &&
1703 echo | $cxx -dM -E - | grep __clang__ >/dev/null 2>&1 ; then
1704 fortify_source="no";
1705 else
1706 fortify_source="yes"
1710 ##########################################
1711 # checks for sanitizers
1713 have_asan=no
1714 have_ubsan=no
1715 have_asan_iface_h=no
1716 have_asan_iface_fiber=no
1718 if test "$sanitizers" = "yes" ; then
1719 write_c_skeleton
1720 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=address" ""; then
1721 have_asan=yes
1724 # we could use a simple skeleton for flags checks, but this also
1725 # detect the static linking issue of ubsan, see also:
1726 # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=84285
1727 cat > $TMPC << EOF
1728 #include <stdlib.h>
1729 int main(void) {
1730 void *tmp = malloc(10);
1731 if (tmp != NULL) {
1732 return *(int *)(tmp + 2);
1734 return 1;
1737 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=undefined" ""; then
1738 have_ubsan=yes
1741 if check_include "sanitizer/asan_interface.h" ; then
1742 have_asan_iface_h=yes
1745 cat > $TMPC << EOF
1746 #include <sanitizer/asan_interface.h>
1747 int main(void) {
1748 __sanitizer_start_switch_fiber(0, 0, 0);
1749 return 0;
1752 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=address" "" ; then
1753 have_asan_iface_fiber=yes
1757 # Thread sanitizer is, for now, much noisier than the other sanitizers;
1758 # keep it separate until that is not the case.
1759 if test "$tsan" = "yes" && test "$sanitizers" = "yes"; then
1760 error_exit "TSAN is not supported with other sanitiziers."
1762 have_tsan=no
1763 have_tsan_iface_fiber=no
1764 if test "$tsan" = "yes" ; then
1765 write_c_skeleton
1766 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=thread" "" ; then
1767 have_tsan=yes
1769 cat > $TMPC << EOF
1770 #include <sanitizer/tsan_interface.h>
1771 int main(void) {
1772 __tsan_create_fiber(0);
1773 return 0;
1776 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=thread" "" ; then
1777 have_tsan_iface_fiber=yes
1781 ##########################################
1782 # functions to probe cross compilers
1784 container="no"
1785 if test $use_containers = "yes" && (has "docker" || has "podman"); then
1786 case $($python "$source_path"/tests/docker/docker.py probe) in
1787 *docker) container=docker ;;
1788 podman) container=podman ;;
1789 no) container=no ;;
1790 esac
1791 if test "$container" != "no"; then
1792 docker_py="$python $source_path/tests/docker/docker.py --engine $container"
1796 # cross compilers defaults, can be overridden with --cross-cc-ARCH
1797 : ${cross_prefix_aarch64="aarch64-linux-gnu-"}
1798 : ${cross_prefix_aarch64_be="$cross_prefix_aarch64"}
1799 : ${cross_prefix_alpha="alpha-linux-gnu-"}
1800 : ${cross_prefix_arm="arm-linux-gnueabihf-"}
1801 : ${cross_prefix_armeb="$cross_prefix_arm"}
1802 : ${cross_prefix_hexagon="hexagon-unknown-linux-musl-"}
1803 : ${cross_prefix_loongarch64="loongarch64-unknown-linux-gnu-"}
1804 : ${cross_prefix_hppa="hppa-linux-gnu-"}
1805 : ${cross_prefix_i386="i686-linux-gnu-"}
1806 : ${cross_prefix_m68k="m68k-linux-gnu-"}
1807 : ${cross_prefix_microblaze="microblaze-linux-musl-"}
1808 : ${cross_prefix_mips64el="mips64el-linux-gnuabi64-"}
1809 : ${cross_prefix_mips64="mips64-linux-gnuabi64-"}
1810 : ${cross_prefix_mipsel="mipsel-linux-gnu-"}
1811 : ${cross_prefix_mips="mips-linux-gnu-"}
1812 : ${cross_prefix_nios2="nios2-linux-gnu-"}
1813 : ${cross_prefix_ppc="powerpc-linux-gnu-"}
1814 : ${cross_prefix_ppc64="powerpc64-linux-gnu-"}
1815 : ${cross_prefix_ppc64le="$cross_prefix_ppc64"}
1816 : ${cross_prefix_riscv64="riscv64-linux-gnu-"}
1817 : ${cross_prefix_s390x="s390x-linux-gnu-"}
1818 : ${cross_prefix_sh4="sh4-linux-gnu-"}
1819 : ${cross_prefix_sparc64="sparc64-linux-gnu-"}
1820 : ${cross_prefix_sparc="$cross_prefix_sparc64"}
1821 : ${cross_prefix_x86_64="x86_64-linux-gnu-"}
1823 : ${cross_cc_aarch64_be="$cross_cc_aarch64"}
1824 : ${cross_cc_cflags_aarch64_be="-mbig-endian"}
1825 : ${cross_cc_armeb="$cross_cc_arm"}
1826 : ${cross_cc_cflags_armeb="-mbig-endian"}
1827 : ${cross_cc_hexagon="hexagon-unknown-linux-musl-clang"}
1828 : ${cross_cc_cflags_hexagon="-mv67 -O2 -static"}
1829 : ${cross_cc_cflags_i386="-m32"}
1830 : ${cross_cc_cflags_ppc="-m32 -mbig-endian"}
1831 : ${cross_cc_cflags_ppc64="-m64 -mbig-endian"}
1832 : ${cross_cc_ppc64le="$cross_cc_ppc64"}
1833 : ${cross_cc_cflags_ppc64le="-m64 -mlittle-endian"}
1834 : ${cross_cc_cflags_sparc64="-m64 -mcpu=ultrasparc"}
1835 : ${cross_cc_sparc="$cross_cc_sparc64"}
1836 : ${cross_cc_cflags_sparc="-m32 -mcpu=supersparc"}
1837 : ${cross_cc_cflags_x86_64="-m64"}
1839 compute_target_variable() {
1840 eval "$2="
1841 if eval test -n "\"\${cross_prefix_$1}\""; then
1842 if eval has "\"\${cross_prefix_$1}\$3\""; then
1843 eval "$2=\"\${cross_prefix_$1}\$3\""
1848 have_target() {
1849 for i; do
1850 case " $target_list " in
1851 *" $i "*) return 0;;
1852 *) ;;
1853 esac
1854 done
1855 return 1
1858 # probe_target_compiler TARGET
1860 # Look for a compiler for the given target, either native or cross.
1861 # Set variables target_* if a compiler is found, and container_cross_*
1862 # if a Docker-based cross-compiler image is known for the target.
1863 # Set got_cross_cc to yes/no depending on whether a non-container-based
1864 # compiler was found.
1866 # If TARGET is a user-mode emulation target, also set build_static to
1867 # "y" if static linking is possible.
1869 probe_target_compiler() {
1870 # reset all output variables
1871 got_cross_cc=no
1872 container_image=
1873 container_hosts=
1874 container_cross_cc=
1875 container_cross_ar=
1876 container_cross_as=
1877 container_cross_ld=
1878 container_cross_nm=
1879 container_cross_objcopy=
1880 container_cross_ranlib=
1881 container_cross_strip=
1883 # We shall skip configuring the target compiler if the user didn't
1884 # bother enabling an appropriate guest. This avoids building
1885 # extraneous firmware images and tests.
1886 if test "${target_list#*$1}" = "$1"; then
1887 return 1
1890 target_arch=${1%%-*}
1891 case $target_arch in
1892 aarch64) container_hosts="x86_64 aarch64" ;;
1893 alpha) container_hosts=x86_64 ;;
1894 arm) container_hosts="x86_64 aarch64" ;;
1895 cris) container_hosts=x86_64 ;;
1896 hexagon) container_hosts=x86_64 ;;
1897 hppa) container_hosts=x86_64 ;;
1898 i386) container_hosts=x86_64 ;;
1899 loongarch64) container_hosts=x86_64 ;;
1900 m68k) container_hosts=x86_64 ;;
1901 microblaze) container_hosts=x86_64 ;;
1902 mips64el) container_hosts=x86_64 ;;
1903 mips64) container_hosts=x86_64 ;;
1904 mipsel) container_hosts=x86_64 ;;
1905 mips) container_hosts=x86_64 ;;
1906 nios2) container_hosts=x86_64 ;;
1907 ppc) container_hosts=x86_64 ;;
1908 ppc64|ppc64le) container_hosts=x86_64 ;;
1909 riscv64) container_hosts=x86_64 ;;
1910 s390x) container_hosts=x86_64 ;;
1911 sh4) container_hosts=x86_64 ;;
1912 sparc64) container_hosts=x86_64 ;;
1913 tricore) container_hosts=x86_64 ;;
1914 x86_64) container_hosts="aarch64 ppc64el x86_64" ;;
1915 xtensa*) container_hosts=x86_64 ;;
1916 esac
1918 for host in $container_hosts; do
1919 test "$container" != no || continue
1920 test "$host" = "$cpu" || continue
1921 case $target_arch in
1922 aarch64)
1923 # We don't have any bigendian build tools so we only use this for AArch64
1924 container_image=debian-arm64-cross
1925 container_cross_prefix=aarch64-linux-gnu-
1926 container_cross_cc=${container_cross_prefix}gcc-10
1928 alpha)
1929 container_image=debian-alpha-cross
1930 container_cross_prefix=alpha-linux-gnu-
1932 arm)
1933 # We don't have any bigendian build tools so we only use this for ARM
1934 container_image=debian-armhf-cross
1935 container_cross_prefix=arm-linux-gnueabihf-
1937 cris)
1938 container_image=fedora-cris-cross
1939 container_cross_prefix=cris-linux-gnu-
1941 hexagon)
1942 container_image=debian-hexagon-cross
1943 container_cross_prefix=hexagon-unknown-linux-musl-
1944 container_cross_cc=${container_cross_prefix}clang
1946 hppa)
1947 container_image=debian-hppa-cross
1948 container_cross_prefix=hppa-linux-gnu-
1950 i386)
1951 container_image=fedora-i386-cross
1952 container_cross_prefix=
1954 loongarch64)
1955 container_image=debian-loongarch-cross
1956 container_cross_prefix=loongarch64-unknown-linux-gnu-
1958 m68k)
1959 container_image=debian-m68k-cross
1960 container_cross_prefix=m68k-linux-gnu-
1962 microblaze)
1963 container_image=debian-microblaze-cross
1964 container_cross_prefix=microblaze-linux-musl-
1966 mips64el)
1967 container_image=debian-mips64el-cross
1968 container_cross_prefix=mips64el-linux-gnuabi64-
1970 mips64)
1971 container_image=debian-mips64-cross
1972 container_cross_prefix=mips64-linux-gnuabi64-
1974 mipsel)
1975 container_image=debian-mipsel-cross
1976 container_cross_prefix=mipsel-linux-gnu-
1978 mips)
1979 container_image=debian-mips-cross
1980 container_cross_prefix=mips-linux-gnu-
1982 nios2)
1983 container_image=debian-nios2-cross
1984 container_cross_prefix=nios2-linux-gnu-
1986 ppc)
1987 container_image=debian-powerpc-test-cross
1988 container_cross_prefix=powerpc-linux-gnu-
1989 container_cross_cc=${container_cross_prefix}gcc-10
1991 ppc64|ppc64le)
1992 container_image=debian-powerpc-test-cross
1993 container_cross_prefix=powerpc${target_arch#ppc}-linux-gnu-
1994 container_cross_cc=${container_cross_prefix}gcc-10
1996 riscv64)
1997 container_image=debian-riscv64-test-cross
1998 container_cross_prefix=riscv64-linux-gnu-
2000 s390x)
2001 container_image=debian-s390x-cross
2002 container_cross_prefix=s390x-linux-gnu-
2004 sh4)
2005 container_image=debian-sh4-cross
2006 container_cross_prefix=sh4-linux-gnu-
2008 sparc64)
2009 container_image=debian-sparc64-cross
2010 container_cross_prefix=sparc64-linux-gnu-
2012 tricore)
2013 container_image=debian-tricore-cross
2014 container_cross_prefix=tricore-
2015 container_cross_as=tricore-as
2016 container_cross_ld=tricore-ld
2017 break
2019 x86_64)
2020 container_image=debian-amd64-cross
2021 container_cross_prefix=x86_64-linux-gnu-
2023 xtensa*)
2024 container_hosts=x86_64
2025 container_image=debian-xtensa-cross
2027 # default to the dc232b cpu
2028 container_cross_prefix=/opt/2020.07/xtensa-dc232b-elf/bin/xtensa-dc232b-elf-
2030 esac
2031 : ${container_cross_cc:=${container_cross_prefix}gcc}
2032 : ${container_cross_ar:=${container_cross_prefix}ar}
2033 : ${container_cross_as:=${container_cross_prefix}as}
2034 : ${container_cross_ld:=${container_cross_prefix}ld}
2035 : ${container_cross_nm:=${container_cross_prefix}nm}
2036 : ${container_cross_objcopy:=${container_cross_prefix}objcopy}
2037 : ${container_cross_ranlib:=${container_cross_prefix}ranlib}
2038 : ${container_cross_strip:=${container_cross_prefix}strip}
2039 done
2041 try=cross
2042 case "$target_arch:$cpu" in
2043 aarch64_be:aarch64 | \
2044 armeb:arm | \
2045 i386:x86_64 | \
2046 mips*:mips64 | \
2047 ppc*:ppc64 | \
2048 sparc:sparc64 | \
2049 "$cpu:$cpu")
2050 try='native cross' ;;
2051 esac
2052 eval "target_cflags=\${cross_cc_cflags_$target_arch}"
2053 for thistry in $try; do
2054 case $thistry in
2055 native)
2056 target_cc=$cc
2057 target_ccas=$ccas
2058 target_ar=$ar
2059 target_as=$as
2060 target_ld=$ld
2061 target_nm=$nm
2062 target_objcopy=$objcopy
2063 target_ranlib=$ranlib
2064 target_strip=$strip
2066 cross)
2067 target_cc=
2068 if eval test -n "\"\${cross_cc_$target_arch}\""; then
2069 if eval has "\"\${cross_cc_$target_arch}\""; then
2070 eval "target_cc=\"\${cross_cc_$target_arch}\""
2072 else
2073 compute_target_variable $target_arch target_cc gcc
2075 target_ccas=$target_cc
2076 compute_target_variable $target_arch target_ar ar
2077 compute_target_variable $target_arch target_as as
2078 compute_target_variable $target_arch target_ld ld
2079 compute_target_variable $target_arch target_nm nm
2080 compute_target_variable $target_arch target_objcopy objcopy
2081 compute_target_variable $target_arch target_ranlib ranlib
2082 compute_target_variable $target_arch target_strip strip
2084 esac
2086 if test -n "$target_cc"; then
2087 case $target_arch in
2088 i386|x86_64)
2089 if $target_cc --version | grep -qi "clang"; then
2090 continue
2093 esac
2094 elif test -n "$target_as" && test -n "$target_ld"; then
2095 # Special handling for assembler only targets
2096 case $target in
2097 tricore-softmmu)
2098 build_static=
2099 got_cross_cc=yes
2100 break
2103 continue
2105 esac
2106 else
2107 continue
2110 write_c_skeleton
2111 case $1 in
2112 *-softmmu)
2113 if do_compiler "$target_cc" $target_cflags -o $TMPO -c $TMPC &&
2114 do_compiler "$target_cc" $target_cflags -r -nostdlib -o "${TMPDIR1}/${TMPB}2.o" "$TMPO" -lgcc; then
2115 got_cross_cc=yes
2116 break
2120 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC -static ; then
2121 build_static=y
2122 got_cross_cc=yes
2123 break
2125 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC ; then
2126 build_static=
2127 got_cross_cc=yes
2128 break
2131 esac
2132 done
2133 if test $got_cross_cc != yes; then
2134 build_static=
2135 target_cc=
2136 target_ccas=
2137 target_ar=
2138 target_as=
2139 target_ld=
2140 target_nm=
2141 target_objcopy=
2142 target_ranlib=
2143 target_strip=
2145 test -n "$target_cc"
2148 write_target_makefile() {
2149 echo "EXTRA_CFLAGS=$target_cflags"
2150 if test -z "$target_cc" && test -z "$target_as"; then
2151 test -z "$container_image" && error_exit "Internal error: could not find cross compiler for $1?"
2152 echo "$1: docker-image-$container_image" >> Makefile.prereqs
2153 if test -n "$container_cross_cc"; then
2154 echo "CC=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
2155 echo "CCAS=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
2157 echo "AR=$docker_py cc --cc $container_cross_ar -i qemu/$container_image -s $source_path --"
2158 echo "AS=$docker_py cc --cc $container_cross_as -i qemu/$container_image -s $source_path --"
2159 echo "LD=$docker_py cc --cc $container_cross_ld -i qemu/$container_image -s $source_path --"
2160 echo "NM=$docker_py cc --cc $container_cross_nm -i qemu/$container_image -s $source_path --"
2161 echo "OBJCOPY=$docker_py cc --cc $container_cross_objcopy -i qemu/$container_image -s $source_path --"
2162 echo "RANLIB=$docker_py cc --cc $container_cross_ranlib -i qemu/$container_image -s $source_path --"
2163 echo "STRIP=$docker_py cc --cc $container_cross_strip -i qemu/$container_image -s $source_path --"
2164 else
2165 if test -n "$target_cc"; then
2166 echo "CC=$target_cc"
2167 echo "CCAS=$target_ccas"
2169 if test -n "$target_ar"; then
2170 echo "AR=$target_ar"
2172 if test -n "$target_as"; then
2173 echo "AS=$target_as"
2175 if test -n "$target_ld"; then
2176 echo "LD=$target_ld"
2178 if test -n "$target_nm"; then
2179 echo "NM=$target_nm"
2181 if test -n "$target_objcopy"; then
2182 echo "OBJCOPY=$target_objcopy"
2184 if test -n "$target_ranlib"; then
2185 echo "RANLIB=$target_ranlib"
2187 if test -n "$target_strip"; then
2188 echo "STRIP=$target_strip"
2193 ##########################################
2194 # check for vfio_user_server
2196 case "$vfio_user_server" in
2197 enabled )
2198 if test "$git_submodules_action" != "ignore"; then
2199 git_submodules="${git_submodules} subprojects/libvfio-user"
2202 esac
2204 ##########################################
2205 # End of CC checks
2206 # After here, no more $cc or $ld runs
2208 write_c_skeleton
2210 if test "$fortify_source" = "yes" ; then
2211 QEMU_CFLAGS="-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 $QEMU_CFLAGS"
2214 if test "$have_asan" = "yes"; then
2215 QEMU_CFLAGS="-fsanitize=address $QEMU_CFLAGS"
2216 QEMU_LDFLAGS="-fsanitize=address $QEMU_LDFLAGS"
2217 if test "$have_asan_iface_h" = "no" ; then
2218 echo "ASAN build enabled, but ASAN header missing." \
2219 "Without code annotation, the report may be inferior."
2220 elif test "$have_asan_iface_fiber" = "no" ; then
2221 echo "ASAN build enabled, but ASAN header is too old." \
2222 "Without code annotation, the report may be inferior."
2225 if test "$have_tsan" = "yes" ; then
2226 if test "$have_tsan_iface_fiber" = "yes" ; then
2227 QEMU_CFLAGS="-fsanitize=thread $QEMU_CFLAGS"
2228 QEMU_LDFLAGS="-fsanitize=thread $QEMU_LDFLAGS"
2229 else
2230 error_exit "Cannot enable TSAN due to missing fiber annotation interface."
2232 elif test "$tsan" = "yes" ; then
2233 error_exit "Cannot enable TSAN due to missing sanitize thread interface."
2235 if test "$have_ubsan" = "yes"; then
2236 QEMU_CFLAGS="-fsanitize=undefined $QEMU_CFLAGS"
2237 QEMU_LDFLAGS="-fsanitize=undefined $QEMU_LDFLAGS"
2240 ##########################################
2241 # Guest agent Windows MSI package
2243 if test "$QEMU_GA_MANUFACTURER" = ""; then
2244 QEMU_GA_MANUFACTURER=QEMU
2246 if test "$QEMU_GA_DISTRO" = ""; then
2247 QEMU_GA_DISTRO=Linux
2249 if test "$QEMU_GA_VERSION" = ""; then
2250 QEMU_GA_VERSION=$(cat "$source_path"/VERSION)
2254 #######################################
2255 # cross-compiled firmware targets
2257 # Set up build tree symlinks that point back into the source tree
2258 # (these can be both files and directories).
2259 # Caution: avoid adding files or directories here using wildcards. This
2260 # will result in problems later if a new file matching the wildcard is
2261 # added to the source tree -- nothing will cause configure to be rerun
2262 # so the build tree will be missing the link back to the new file, and
2263 # tests might fail. Prefer to keep the relevant files in their own
2264 # directory and symlink the directory instead.
2265 LINKS="Makefile"
2266 LINKS="$LINKS pc-bios/optionrom/Makefile"
2267 LINKS="$LINKS pc-bios/s390-ccw/Makefile"
2268 LINKS="$LINKS pc-bios/vof/Makefile"
2269 LINKS="$LINKS .gdbinit scripts" # scripts needed by relative path in .gdbinit
2270 LINKS="$LINKS tests/avocado tests/data"
2271 LINKS="$LINKS tests/qemu-iotests/check"
2272 LINKS="$LINKS python"
2273 LINKS="$LINKS contrib/plugins/Makefile "
2274 for f in $LINKS ; do
2275 if [ -e "$source_path/$f" ]; then
2276 mkdir -p "$(dirname ./"$f")"
2277 symlink "$source_path/$f" "$f"
2279 done
2281 echo "# Automatically generated by configure - do not modify" > Makefile.prereqs
2283 # Mac OS X ships with a broken assembler
2284 roms=
2285 if have_target i386-softmmu x86_64-softmmu && \
2286 test "$targetos" != "darwin" && test "$targetos" != "sunos" && \
2287 test "$targetos" != "haiku" && \
2288 probe_target_compiler i386-softmmu; then
2289 roms="pc-bios/optionrom"
2290 config_mak=pc-bios/optionrom/config.mak
2291 echo "# Automatically generated by configure - do not modify" > $config_mak
2292 echo "TOPSRC_DIR=$source_path" >> $config_mak
2293 write_target_makefile >> $config_mak
2296 if have_target ppc-softmmu ppc64-softmmu && \
2297 probe_target_compiler ppc-softmmu; then
2298 roms="$roms pc-bios/vof"
2299 config_mak=pc-bios/vof/config.mak
2300 echo "# Automatically generated by configure - do not modify" > $config_mak
2301 echo "SRC_DIR=$source_path/pc-bios/vof" >> $config_mak
2302 write_target_makefile >> $config_mak
2305 # Only build s390-ccw bios if the compiler has -march=z900 or -march=z10
2306 # (which is the lowest architecture level that Clang supports)
2307 if have_target s390x-softmmu && probe_target_compiler s390x-softmmu; then
2308 write_c_skeleton
2309 do_compiler "$target_cc" $target_cc_cflags -march=z900 -o $TMPO -c $TMPC
2310 has_z900=$?
2311 if [ $has_z900 = 0 ] || do_compiler "$target_cc" $target_cc_cflags -march=z10 -msoft-float -Werror -o $TMPO -c $TMPC; then
2312 if [ $has_z900 != 0 ]; then
2313 echo "WARNING: Your compiler does not support the z900!"
2314 echo " The s390-ccw bios will only work with guest CPUs >= z10."
2316 roms="$roms pc-bios/s390-ccw"
2317 config_mak=pc-bios/s390-ccw/config-host.mak
2318 echo "# Automatically generated by configure - do not modify" > $config_mak
2319 echo "SRC_PATH=$source_path/pc-bios/s390-ccw" >> $config_mak
2320 write_target_makefile >> $config_mak
2321 # SLOF is required for building the s390-ccw firmware on s390x,
2322 # since it is using the libnet code from SLOF for network booting.
2323 git_submodules="${git_submodules} roms/SLOF"
2327 #######################################
2328 # generate config-host.mak
2330 if ! (GIT="$git" "$source_path/scripts/git-submodule.sh" "$git_submodules_action" "$git_submodules"); then
2331 exit 1
2334 config_host_mak="config-host.mak"
2336 echo "# Automatically generated by configure - do not modify" > $config_host_mak
2337 echo >> $config_host_mak
2339 echo all: >> $config_host_mak
2340 echo "GIT=$git" >> $config_host_mak
2341 echo "GIT_SUBMODULES=$git_submodules" >> $config_host_mak
2342 echo "GIT_SUBMODULES_ACTION=$git_submodules_action" >> $config_host_mak
2344 if test "$debug_tcg" = "yes" ; then
2345 echo "CONFIG_DEBUG_TCG=y" >> $config_host_mak
2347 if test "$mingw32" = "yes" ; then
2348 echo "CONFIG_WIN32=y" >> $config_host_mak
2349 echo "QEMU_GA_MANUFACTURER=${QEMU_GA_MANUFACTURER}" >> $config_host_mak
2350 echo "QEMU_GA_DISTRO=${QEMU_GA_DISTRO}" >> $config_host_mak
2351 echo "QEMU_GA_VERSION=${QEMU_GA_VERSION}" >> $config_host_mak
2352 else
2353 echo "CONFIG_POSIX=y" >> $config_host_mak
2356 if test "$linux" = "yes" ; then
2357 echo "CONFIG_LINUX=y" >> $config_host_mak
2360 if test "$darwin" = "yes" ; then
2361 echo "CONFIG_DARWIN=y" >> $config_host_mak
2364 if test "$solaris" = "yes" ; then
2365 echo "CONFIG_SOLARIS=y" >> $config_host_mak
2367 if test "$static" = "yes" ; then
2368 echo "CONFIG_STATIC=y" >> $config_host_mak
2370 echo "SRC_PATH=$source_path" >> $config_host_mak
2371 echo "TARGET_DIRS=$target_list" >> $config_host_mak
2372 if test "$modules" = "yes"; then
2373 echo "CONFIG_MODULES=y" >> $config_host_mak
2376 # XXX: suppress that
2377 if [ "$bsd" = "yes" ] ; then
2378 echo "CONFIG_BSD=y" >> $config_host_mak
2381 echo "CONFIG_COROUTINE_BACKEND=$coroutine" >> $config_host_mak
2383 if test "$have_asan_iface_fiber" = "yes" ; then
2384 echo "CONFIG_ASAN_IFACE_FIBER=y" >> $config_host_mak
2387 if test "$have_tsan" = "yes" && test "$have_tsan_iface_fiber" = "yes" ; then
2388 echo "CONFIG_TSAN=y" >> $config_host_mak
2391 if test "$plugins" = "yes" ; then
2392 echo "CONFIG_PLUGIN=y" >> $config_host_mak
2395 if test -n "$gdb_bin"; then
2396 gdb_version=$($gdb_bin --version | head -n 1)
2397 if version_ge ${gdb_version##* } 9.1; then
2398 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
2399 else
2400 gdb_bin=""
2404 if test "$container" != no; then
2405 echo "ENGINE=$container" >> $config_host_mak
2407 echo "ROMS=$roms" >> $config_host_mak
2408 echo "MAKE=$make" >> $config_host_mak
2409 echo "PYTHON=$python" >> $config_host_mak
2410 echo "GENISOIMAGE=$genisoimage" >> $config_host_mak
2411 echo "MESON=$meson" >> $config_host_mak
2412 echo "NINJA=$ninja" >> $config_host_mak
2413 echo "CC=$cc" >> $config_host_mak
2414 echo "QEMU_CFLAGS=$QEMU_CFLAGS" >> $config_host_mak
2415 echo "QEMU_OBJCFLAGS=$QEMU_OBJCFLAGS" >> $config_host_mak
2416 echo "GLIB_CFLAGS=$glib_cflags" >> $config_host_mak
2417 echo "GLIB_LIBS=$glib_libs" >> $config_host_mak
2418 echo "GLIB_BINDIR=$glib_bindir" >> $config_host_mak
2419 echo "GLIB_VERSION=$(pkg-config --modversion glib-2.0)" >> $config_host_mak
2420 echo "QEMU_LDFLAGS=$QEMU_LDFLAGS" >> $config_host_mak
2421 echo "EXESUF=$EXESUF" >> $config_host_mak
2423 # use included Linux headers
2424 if test "$linux" = "yes" ; then
2425 mkdir -p linux-headers
2426 case "$cpu" in
2427 i386|x86_64)
2428 linux_arch=x86
2430 ppc|ppc64)
2431 linux_arch=powerpc
2433 s390x)
2434 linux_arch=s390
2436 aarch64)
2437 linux_arch=arm64
2439 loongarch*)
2440 linux_arch=loongarch
2442 mips64)
2443 linux_arch=mips
2446 # For most CPUs the kernel architecture name and QEMU CPU name match.
2447 linux_arch="$cpu"
2449 esac
2450 # For non-KVM architectures we will not have asm headers
2451 if [ -e "$source_path/linux-headers/asm-$linux_arch" ]; then
2452 symlink "$source_path/linux-headers/asm-$linux_arch" linux-headers/asm
2456 for target in $target_list; do
2457 target_dir="$target"
2458 target_name=$(echo $target | cut -d '-' -f 1)$EXESUF
2459 mkdir -p "$target_dir"
2460 case $target in
2461 *-user) symlink "../qemu-$target_name" "$target_dir/qemu-$target_name" ;;
2462 *) symlink "../qemu-system-$target_name" "$target_dir/qemu-system-$target_name" ;;
2463 esac
2464 done
2466 if test "$default_targets" = "yes"; then
2467 echo "CONFIG_DEFAULT_TARGETS=y" >> $config_host_mak
2470 if test "$ccache_cpp2" = "yes"; then
2471 echo "export CCACHE_CPP2=y" >> $config_host_mak
2474 if test "$safe_stack" = "yes"; then
2475 echo "CONFIG_SAFESTACK=y" >> $config_host_mak
2478 # tests/tcg configuration
2479 (config_host_mak=tests/tcg/config-host.mak
2480 mkdir -p tests/tcg
2481 echo "# Automatically generated by configure - do not modify" > $config_host_mak
2482 echo "SRC_PATH=$source_path" >> $config_host_mak
2483 echo "HOST_CC=$host_cc" >> $config_host_mak
2485 # versioned checked in the main config_host.mak above
2486 if test -n "$gdb_bin"; then
2487 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
2489 if test "$plugins" = "yes" ; then
2490 echo "CONFIG_PLUGIN=y" >> $config_host_mak
2493 tcg_tests_targets=
2494 for target in $target_list; do
2495 arch=${target%%-*}
2497 case $target in
2498 xtensa*-linux-user)
2499 # the toolchain is not complete with headers, only build softmmu tests
2500 continue
2502 *-softmmu)
2503 test -f "$source_path/tests/tcg/$arch/Makefile.softmmu-target" || continue
2504 qemu="qemu-system-$arch"
2506 *-linux-user|*-bsd-user)
2507 qemu="qemu-$arch"
2509 esac
2511 if probe_target_compiler $target || test -n "$container_image"; then
2512 test -n "$container_image" && build_static=y
2513 mkdir -p "tests/tcg/$target"
2514 config_target_mak=tests/tcg/$target/config-target.mak
2515 ln -sf "$source_path/tests/tcg/Makefile.target" "tests/tcg/$target/Makefile"
2516 echo "# Automatically generated by configure - do not modify" > "$config_target_mak"
2517 echo "TARGET_NAME=$arch" >> "$config_target_mak"
2518 echo "TARGET=$target" >> "$config_target_mak"
2519 write_target_makefile "build-tcg-tests-$target" >> "$config_target_mak"
2520 echo "BUILD_STATIC=$build_static" >> "$config_target_mak"
2521 echo "QEMU=$PWD/$qemu" >> "$config_target_mak"
2522 echo "run-tcg-tests-$target: $qemu\$(EXESUF)" >> Makefile.prereqs
2523 tcg_tests_targets="$tcg_tests_targets $target"
2525 done
2526 echo "TCG_TESTS_TARGETS=$tcg_tests_targets" >> config-host.mak)
2528 if test "$skip_meson" = no; then
2529 cross="config-meson.cross.new"
2530 meson_quote() {
2531 test $# = 0 && return
2532 echo "'$(echo $* | sed "s/ /','/g")'"
2535 echo "# Automatically generated by configure - do not modify" > $cross
2536 echo "[properties]" >> $cross
2538 # unroll any custom device configs
2539 for a in $device_archs; do
2540 eval "c=\$devices_${a}"
2541 echo "${a}-softmmu = '$c'" >> $cross
2542 done
2544 echo "[built-in options]" >> $cross
2545 echo "c_args = [$(meson_quote $CFLAGS $EXTRA_CFLAGS)]" >> $cross
2546 echo "cpp_args = [$(meson_quote $CXXFLAGS $EXTRA_CXXFLAGS)]" >> $cross
2547 test -n "$objcc" && echo "objc_args = [$(meson_quote $OBJCFLAGS $EXTRA_OBJCFLAGS)]" >> $cross
2548 echo "c_link_args = [$(meson_quote $CFLAGS $LDFLAGS $EXTRA_CFLAGS $EXTRA_LDFLAGS)]" >> $cross
2549 echo "cpp_link_args = [$(meson_quote $CXXFLAGS $LDFLAGS $EXTRA_CXXFLAGS $EXTRA_LDFLAGS)]" >> $cross
2550 echo "[binaries]" >> $cross
2551 echo "c = [$(meson_quote $cc $CPU_CFLAGS)]" >> $cross
2552 test -n "$cxx" && echo "cpp = [$(meson_quote $cxx $CPU_CFLAGS)]" >> $cross
2553 test -n "$objcc" && echo "objc = [$(meson_quote $objcc $CPU_CFLAGS)]" >> $cross
2554 echo "ar = [$(meson_quote $ar)]" >> $cross
2555 echo "nm = [$(meson_quote $nm)]" >> $cross
2556 echo "pkgconfig = [$(meson_quote $pkg_config_exe)]" >> $cross
2557 echo "ranlib = [$(meson_quote $ranlib)]" >> $cross
2558 if has $sdl2_config; then
2559 echo "sdl2-config = [$(meson_quote $sdl2_config)]" >> $cross
2561 echo "strip = [$(meson_quote $strip)]" >> $cross
2562 echo "widl = [$(meson_quote $widl)]" >> $cross
2563 echo "windres = [$(meson_quote $windres)]" >> $cross
2564 echo "windmc = [$(meson_quote $windmc)]" >> $cross
2565 if test "$cross_compile" = "yes"; then
2566 cross_arg="--cross-file config-meson.cross"
2567 echo "[host_machine]" >> $cross
2568 echo "system = '$targetos'" >> $cross
2569 case "$cpu" in
2570 i386)
2571 echo "cpu_family = 'x86'" >> $cross
2574 echo "cpu_family = '$cpu'" >> $cross
2576 esac
2577 echo "cpu = '$cpu'" >> $cross
2578 if test "$bigendian" = "yes" ; then
2579 echo "endian = 'big'" >> $cross
2580 else
2581 echo "endian = 'little'" >> $cross
2583 else
2584 cross_arg="--native-file config-meson.cross"
2586 mv $cross config-meson.cross
2588 rm -rf meson-private meson-info meson-logs
2590 # Built-in options
2591 test "$bindir" != "bin" && meson_option_add "-Dbindir=$bindir"
2592 test "$default_feature" = no && meson_option_add -Dauto_features=disabled
2593 test "$pie" = no && meson_option_add -Db_pie=false
2594 test "$werror" = yes && meson_option_add -Dwerror=true
2596 # QEMU options
2597 test "$cfi" != false && meson_option_add "-Dcfi=$cfi"
2598 test "$fdt" != auto && meson_option_add "-Dfdt=$fdt"
2599 test -n "${LIB_FUZZING_ENGINE+xxx}" && meson_option_add "-Dfuzzing_engine=$LIB_FUZZING_ENGINE"
2600 test "$qemu_suffix" != qemu && meson_option_add "-Dqemu_suffix=$qemu_suffix"
2601 test "$smbd" != '' && meson_option_add "-Dsmbd=$smbd"
2602 test "$tcg" != enabled && meson_option_add "-Dtcg=$tcg"
2603 test "$vfio_user_server" != auto && meson_option_add "-Dvfio_user_server=$vfio_user_server"
2604 run_meson() {
2605 NINJA=$ninja $meson setup --prefix "$prefix" "$@" $cross_arg "$PWD" "$source_path"
2607 eval run_meson $meson_options
2608 if test "$?" -ne 0 ; then
2609 error_exit "meson setup failed"
2611 else
2612 if test -f meson-private/cmd_line.txt; then
2613 # Adjust old command line options whose type was changed
2614 # Avoids having to use "setup --wipe" when Meson is upgraded
2615 perl -i -ne '
2616 s/^gettext = true$/gettext = auto/;
2617 s/^gettext = false$/gettext = disabled/;
2618 /^b_staticpic/ && next;
2619 print;' meson-private/cmd_line.txt
2623 # Save the configure command line for later reuse.
2624 cat <<EOD >config.status
2625 #!/bin/sh
2626 # Generated by configure.
2627 # Run this file to recreate the current configuration.
2628 # Compiler output produced by configure, useful for debugging
2629 # configure, is in config.log if it exists.
2632 preserve_env() {
2633 envname=$1
2635 eval envval=\$$envname
2637 if test -n "$envval"
2638 then
2639 echo "$envname='$envval'" >> config.status
2640 echo "export $envname" >> config.status
2641 else
2642 echo "unset $envname" >> config.status
2646 # Preserve various env variables that influence what
2647 # features/build target configure will detect
2648 preserve_env AR
2649 preserve_env AS
2650 preserve_env CC
2651 preserve_env CFLAGS
2652 preserve_env CXX
2653 preserve_env CXXFLAGS
2654 preserve_env LD
2655 preserve_env LDFLAGS
2656 preserve_env LD_LIBRARY_PATH
2657 preserve_env MAKE
2658 preserve_env NM
2659 preserve_env OBJCFLAGS
2660 preserve_env OBJCOPY
2661 preserve_env PATH
2662 preserve_env PKG_CONFIG
2663 preserve_env PKG_CONFIG_LIBDIR
2664 preserve_env PKG_CONFIG_PATH
2665 preserve_env PYTHON
2666 preserve_env SDL2_CONFIG
2667 preserve_env SMBD
2668 preserve_env STRIP
2669 preserve_env WIDL
2670 preserve_env WINDRES
2671 preserve_env WINDMC
2673 printf "exec" >>config.status
2674 for i in "$0" "$@"; do
2675 test "$i" = --skip-meson || printf " %s" "$(quote_sh "$i")" >>config.status
2676 done
2677 echo ' "$@"' >>config.status
2678 chmod +x config.status
2680 rm -r "$TMPDIR1"